# 2.2.x Stable Releases

See https://www.pantsbuild.org/v2.2/docs/release-notes-2-2 for an overview of the changes in this release series.

This is the first release to require having a Python 3.7 or 3.8 interpreter to run Pants. Run `curl -L -o ./pants 
https://raw.githubusercontent.com/pantsbuild/setup/2f079cbe4fc6a1d9d87decba51f19d7689aee69e/pants` to update your
`./pants` script to choose the correct interpreter.

## 2.2.4 (Jun 16, 2021)

The fifth stable release of the `2.2.x` series, with no changes since the previous `rc`.

## 2.2.4rc0 (Jun 02, 2021)

### Bug fixes

* Fix `Key` interning race causing `panic while processing panic` failure (Cherry-pick of #12152) ([#12161](https://github.com/pantsbuild/pants/pull/12161))

## 2.2.3 (May 6, 2021)

The fourth stable release of the `2.2.x` series, with no changes since the previous `rc`.

## 2.2.3rc0 (Apr 29, 2021)

### User API Changes

* Revert deprecation of `interpreter_constraints` field for `pex_binary` and `python_awslambda` ([#11981](https://github.com/pantsbuild/pants/pull/11981))

## 2.2.2 (Apr 20, 2021)

The third stable release of the `2.2.x` series, with no changes since the previous `rc`.

## 2.2.2rc1 (Apr 14, 2021)

### Bug fixes

* Allow Python files without a file ending (Cherry-pick of #11905) ([#11918](https://github.com/pantsbuild/pants/pull/11918))

* Fix bug in Python 2.7 string dep inference. (Cherry-pick of #11900) ([#11906](https://github.com/pantsbuild/pants/pull/11906))

## 2.2.2rc0 (April 10, 2021)

### Bug fixes

* Fix a bug in unicode string dep inference. (cherrypick of #11879) ([#11881](https://github.com/pantsbuild/pants/pull/11881))

## 2.2.1 (Mar 18, 2021)

The second stable release in the `2.2.x` series, with no changes since the previous rc.

## 2.2.1rc2 (Mar 17, 2021)

### Bug fixes

* Fix a deadlock involving `scheduler.all_digests`, and add a note. (cherrypick of #11723) ([#11725](https://github.com/pantsbuild/pants/pull/11725))

* Upgrade to Pex 2.1.34 to pull in a fix for an import race. (cherrypick of #11711) ([#11714](https://github.com/pantsbuild/pants/pull/11714))

## 2.2.1rc1 (Mar 12, 2021)

### Bug fixes

* Fix PYTHONPATH not including protobuf targets using `python_source_root`  (Cherry-pick of #11673) ([#11676](https://github.com/pantsbuild/pants/pull/11676))

## 2.2.1rc0 (March 10, 2021)

### Bug fixes

* Do not interpret passthrough args. (cherrypick of #11656) ([#11661](https://github.com/pantsbuild/pants/pull/11661))

* Fix MyPy to work by default with Python 3.9+ (Cherry-pick of #11537) ([#11542](https://github.com/pantsbuild/pants/pull/11542))

* Fix excessive mmap-ing in LMDB (cherrypick of #11513) ([#11516](https://github.com/pantsbuild/pants/pull/11516))

## 2.2.0 (Jan 20, 2021)

The first stable release in the `2.2.x` series, with no changes since the previous `rc`!

## 2.2.0rc2 (Jan 11, 2021)

### Bug fixes

* Fix `--opt` options in constraints.txt files erroring (#11407) ([#11425](https://github.com/pantsbuild/pants/pull/11425))

* Fix older versions of `tar` not working when creating an `archive` (#11413) ([#11419](https://github.com/pantsbuild/pants/pull/11419))

## 2.2.0rc1 (Dec 30, 2020)

### Bug fixes

* Move to having the Scheduler directly handle SIGINT to cancel all relevant Sessions. ([#11399](https://github.com/pantsbuild/pants/pull/11399))

* Fix docstring deprecation warning for Bandit. ([#11395](https://github.com/pantsbuild/pants/pull/11395))

## 2.2.0rc0 (Dec 28, 2020)

### New Features

* Infer imports of the style `__import__("string_literal")`. ([#11326](https://github.com/pantsbuild/pants/pull/11326))

* Make the number of threads used to run @rules in the Engine configurable. ([#11325](https://github.com/pantsbuild/pants/pull/11325))

* Expose `--resolver-version` to support using the new pip resolver, deprecate `--cache-ttl`. ([#11349](https://github.com/pantsbuild/pants/pull/11349))

### User API Changes

* Bump default version of Pytest to 6.2.x ([#11381](https://github.com/pantsbuild/pants/pull/11381))

* Upgrade packaging from 20.7 to 20.8 ([#11343](https://github.com/pantsbuild/pants/pull/11343))

* Deprecate the `sources` field for `pex_binary` and `python_awslambda` ([#11332](https://github.com/pantsbuild/pants/pull/11332))

### Plugin API Changes

* Deprecate Subsystems as global singletons ([#11388](https://github.com/pantsbuild/pants/pull/11388))

* Add shortcut public API method to return cumulative timings data. ([#11385](https://github.com/pantsbuild/pants/pull/11385))

* Remove unused get_critical_path_timings() API ([#11387](https://github.com/pantsbuild/pants/pull/11387))

* Deprecate not setting `help` for Targets, Fields, and Subsystems ([#11380](https://github.com/pantsbuild/pants/pull/11380))

* RunTracker: add goals property ([#11382](https://github.com/pantsbuild/pants/pull/11382))

### Bug fixes

* Explicitly flush stdio in the nailgun client. ([#11383](https://github.com/pantsbuild/pants/pull/11383))

* Ignore exit on the nailgun Client output_stream. ([#11358](https://github.com/pantsbuild/pants/pull/11358))

### Performance

* avoid unnecessary copy in cache code path ([#11348](https://github.com/pantsbuild/pants/pull/11348))

* use Bytes instead of Vec<u8> for protobuf binary fields ([#11342](https://github.com/pantsbuild/pants/pull/11342))

* refactor all gRPC usages to use Tonic instead of grpcio ([#11307](https://github.com/pantsbuild/pants/pull/11307))

* fs.Snapshot is declared in Rust ([#11328](https://github.com/pantsbuild/pants/pull/11328))

* Interrupt Graph tasks on Ctrl+C ([#11322](https://github.com/pantsbuild/pants/pull/11322))

### Documentation

* Pin references to docs to the current version ([#11369](https://github.com/pantsbuild/pants/pull/11369))

* Generate docs references for target types ([#11340](https://github.com/pantsbuild/pants/pull/11340))

## 2.2.0.dev2 (Dec 16, 2020)

### Plugin API Changes

* Upgrade packaging from 20.4 to 20.7 ([#11302](https://github.com/pantsbuild/pants/pull/11302))

* Update default values for run tracker and streaming work unit handlers to more commonly used values. ([#11292](https://github.com/pantsbuild/pants/pull/11292))

### Bug fixes

* Fix filtering of log messages generated in native code. ([#11313](https://github.com/pantsbuild/pants/pull/11313))

* Upgrade to Pex 2.1.24 to fix macOS Big Sur. ([#11312](https://github.com/pantsbuild/pants/pull/11312))

* Clean the graph speculatively, and cancel nodes when interest is lost ([#11308](https://github.com/pantsbuild/pants/pull/11308))

* Implement native Process cache scoping to fix --test-force ([#11291](https://github.com/pantsbuild/pants/pull/11291))

## 2.2.0.dev1 (Dec 09, 2020)

### New Features

* Add shorthand to use a file name for `pex_binary`'s `entry_point` and `python_awslambda`'s `handler` field ([#11261](https://github.com/pantsbuild/pants/pull/11261))

* Add dependency inference for `pex_binary`'s `entry_point` and `python_awslambda`'s `handler` fields ([#11245](https://github.com/pantsbuild/pants/pull/11245))

* Allow file arguments to work with the `app.py` shorthand for `pex_binary` and `python_awslambda` ([#11263](https://github.com/pantsbuild/pants/pull/11263))

* Warn if `package` and `test` have no matching files/targets ([#11240](https://github.com/pantsbuild/pants/pull/11240))

### User API Changes

* 2.2.0.dev1 deprecations. ([#11281](https://github.com/pantsbuild/pants/pull/11281))

* Require `pex_binary`'s `platforms` field to be a list ([#11246](https://github.com/pantsbuild/pants/pull/11246))

* Remove deprecated `--pants-distdir-legacy-paths` option ([#11247](https://github.com/pantsbuild/pants/pull/11247))

### Bug fixes

* Increase Pants' python recursion limit by default, and allow it to be overridden. ([#11271](https://github.com/pantsbuild/pants/pull/11271))

* Stop logging if Pyenv not installed ([#11243](https://github.com/pantsbuild/pants/pull/11243))

### Performance

* Reduce interning overhead ([#11262](https://github.com/pantsbuild/pants/pull/11262))

* Parallelize the `Owners` rule more ([#11260](https://github.com/pantsbuild/pants/pull/11260))

### Documentation

* Update Pants prerequisites facts. ([#11265](https://github.com/pantsbuild/pants/pull/11265))

## 2.2.0.dev0 (Nov 24, 2020)

### New Features

* Add dependency inference for Protobuf <-> Protobuf imports ([#11205](https://github.com/pantsbuild/pants/pull/11205))

* Add dependency inference for Python imports of Protobuf/gRPC ([#11195](https://github.com/pantsbuild/pants/pull/11195))

* Allow setting the entry point for a `pex_binary` to `<none>` ([#11199](https://github.com/pantsbuild/pants/pull/11199))

* Add support for filtering file vs BUILD targets ([#11126](https://github.com/pantsbuild/pants/pull/11126))

* Cancel sessions rather than killing pantsd ([#11123](https://github.com/pantsbuild/pants/pull/11123))

* Remoting: allow timeout parameters to be configured ([#11125](https://github.com/pantsbuild/pants/pull/11125))

### User API Changes

* Require Python 3.7 or 3.8 to run Pants ([#11135](https://github.com/pantsbuild/pants/pull/11135))

* Deprecate `mypy_source_plugin` and `pylint_source_plugin` targets in favor of `python_library` ([#11233](https://github.com/pantsbuild/pants/pull/11233))

* Remove deprecated `compatibility` field in favor of `interpreter_constraints` ([#11225](https://github.com/pantsbuild/pants/pull/11225))

* Upgrade to Pex 2.1.21. ([#11131](https://github.com/pantsbuild/pants/pull/11131))

### Plugin API Changes

* Remove `PrimitiveField` and align `AsyncField` with `Field` ([#11231](https://github.com/pantsbuild/pants/pull/11231))

* Change `AsyncField` to be `AsyncFieldMixin` ([#11232](https://github.com/pantsbuild/pants/pull/11232))

* Deprecate `TransitiveTargetsRequestLite` and `DependenciesRequestLite` now that graph cycle is fixed ([#11188](https://github.com/pantsbuild/pants/pull/11188))

### Bug fixes

* Fix dependency inference parsing of Python 3.8 and 3.9 syntax ([#11213](https://github.com/pantsbuild/pants/pull/11213))

* Set the soft ulimit value more conservatively to fix macOS Big Sur issue ([#11194](https://github.com/pantsbuild/pants/pull/11194))

* Move graph cycle detection to Rust to fix recursion limit. ([#11202](https://github.com/pantsbuild/pants/pull/11202))

* Fix relative imports in dependency inference ([#11181](https://github.com/pantsbuild/pants/pull/11181))

* Remove extraneous info level log line ([#11228](https://github.com/pantsbuild/pants/pull/11228))

* Fix Coverage not finding resource files when generating a report ([#11129](https://github.com/pantsbuild/pants/pull/11129))

* Fix `test` results showing up twice by removing `TargetsWithOrigin` ([#11128](https://github.com/pantsbuild/pants/pull/11128))

* Make a few minor reliability fixes to remote caching code ([#11130](https://github.com/pantsbuild/pants/pull/11130))

### Documentation

* Improve error message for no applicable targets ([#11215](https://github.com/pantsbuild/pants/pull/11215))
